import useModelStore, { DecalSticker } from "@/store/useModelStore";
import { Decal, useTexture } from "@react-three/drei";
// import { Euler } from "three";

/**
 * logo 和文字标签
 * @param param0
 * @returns
 */
const Sticker = ({ decal }: { decal: DecalSticker }) => {
  const sticker = useTexture(decal.url);
  const setDecalDragging = useModelStore((state) => state.setDecalDragging);
  const setDecalScale = useModelStore((state) => state.setDecalScale);
  const setActiveDecal = useModelStore((state) => state.setActiveDecal);
  // useInterval(() => {
  //     setRotation(state => state += 0.001 * Math.PI)
  // }, 10)
  return (
    <Decal
      debug={true}
      position={decal.position}
      scale={decal.scale}
      onPointerDown={(ev) => {
        ev.stopPropagation();
        setActiveDecal(decal.id);
        setDecalDragging(true);
      }}
      onPointerUp={(ev) => {
        ev.stopPropagation();
        setDecalDragging(false);
      }}
      onWheel={(ev) => {
        ev.stopPropagation();
        // setDecalDragging(true);
        // setDecals()
        if (!ev.altKey) return;
        if (ev.deltaY > 0) {
          // setScale(state => state += 0.01)
          setDecalScale(decal.id, (decal.scale -= 0.01));
        } else if (ev.deltaY < 0) {
          setDecalScale(decal.id, (decal.scale += 0.01));
          // setScale(state => state -= 0.01)
        }
      }}
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-expect-error
      rotation={Math.PI}
      // rotation={new Euler(Math.PI * euler.x, Math.PI * euler.y, Math.PI * euler.z)}
      // rotation={[Math.PI * 1, Math.PI * 1, Math.PI * 1]}
    >
      <meshPhysicalMaterial
        transparent
        polygonOffset
        polygonOffsetFactor={-10}
        map={sticker}
        map-flipY={false}
        map-anisotropy={16}
        iridescence={1}
        iridescenceIOR={1}
        iridescenceThicknessRange={[0, 1400]}
        roughness={1}
        clearcoat={0.5}
        metalness={0.75}
        toneMapped={false}
      />
    </Decal>
  );
};

export default Sticker;
